unit main;
{ XML-RPC Client Main form. }
interface

uses
    opml, xmlrpc_cli, verres, // original unit.
    JclUnicode, // Project JEDI http://projectjedi.sourceforge.net/
    LibXmlParser, // XML Parser http://www.destructor.de/
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP, // Indy(Internet direct) http://www.nevrona.com/Indy/
  IniFiles,contnrs,ShellAPI,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,Menus, ComCtrls,
  ExtCtrls, ToolWin, ImgList, ActnList, Buttons,
  AppEvnts, FileCtrl;

const
 DELIM_MARK = ' --- ';

 TITLE_SIG = '[Signature of %s]';
 TITLE_HELP = '[Help of %s]';

 DEFAULT_SERVICE = 'service.opml';
 DEFAULT_REQUEST = '<?xml version="1.0"?>'#13#10'<methodCall>'#13#10'<methodName><!-- Method name Here!! --></methodName>'#13#10
                 +'<params><param>'#13#10'<value><!-- Method Parameter 1 Here!! --></value>'#13#10'<value><!-- Method Parameter 2 Here!! --></value>'#13#10'<value><!-- Method Parameter n Here!! --></value>'#13#10'</param></params>'#13#10'</methodCall>'#13#10
                 ;

 SYSTEM_LIST_METHODS = '<?xml version="1.0"?><methodCall><methodName>system.listMethods</methodName></methodCall>';
 SYSTEM_METHOD_HELP = '<?xml version="1.0"?><methodCall><methodName>system.methodHelp</methodName><params><param><value><string>%s</string></value></param></params></methodCall>';
 SYSTEM_METHOD_SIG = '<?xml version="1.0"?><methodCall><methodName>system.methodSignature</methodName><params><param><value><string>%s</string></value></param></params></methodCall>';

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    FileMenu: TMenuItem;
    ExitItem: TMenuItem;
    N1: TMenuItem;
    OpenItem: TMenuItem;
    OpenDialog: TOpenDialog;
    http: TIdHTTP;
    HelpMenu: TMenuItem;
    HelpItem: TMenuItem;
    AboutItem: TMenuItem;
    XMLRPCspecItem: TMenuItem;
    XMLRPCIntrospection1: TMenuItem;
    XMLRPCHowto1: TMenuItem;
    XMLRPCHOWTOinJapanese1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    YubinSenmonnetItem: TMenuItem;
    PopupMenu1: TPopupMenu;
    HelpSignature1: TMenuItem;
    methodHelp1: TMenuItem;
    methodSignature1: TMenuItem;
    ToolTopPanel: TPanel;
    StatusBar: TStatusBar;
    ActionList1: TActionList;
    OpenRequestFile: TAction;
    OpenReqestFileBtn: TSpeedButton;
    ImageList1: TImageList;
    PagesRoot: TPageControl;
    tabXMLRPC: TTabSheet;
    tabSettings: TTabSheet;
    Pages: TPageControl;
    tabSystem: TTabSheet;
    Label4: TLabel;
    listMethodsBtn: TButton;
    Introspects: TGroupBox;
    Label2: TLabel;
    methodHelpBtn: TButton;
    methodSignatureBtn: TButton;
    MethodNameList: TListBox;
    BothBtn: TButton;
    ClearMetodNamesBtn: TButton;
    tabRequest: TTabSheet;
    Request: TMemo;
    Panel1: TPanel;
    ExecuteRequestBtn: TButton;
    tabResponse: TTabSheet;
    Splitter1: TSplitter;
    Response: TMemo;
    ResponseMsg: TMemo;
    ProxyConnectionSetting: TGroupBox;
    lbProxyHost: TLabel;
    LabelPort: TLabel;
    ProxyHost: TEdit;
    ProxyPort: TEdit;
    ApplicationEvents1: TApplicationEvents;
    ExplolorPanel: TPanel;
    Splitter2: TSplitter;
    DirectoryListBox: TDirectoryListBox;
    FileListBox: TFileListBox;
    DriveComboBox: TDriveComboBox;
    FilterComboBox: TFilterComboBox;
    Panel2: TPanel;
    uril: TLabel;
    uri: TEdit;
    lbHost: TLabel;
    lbPort: TLabel;
    port: TEdit;
    GroupBox1: TGroupBox;
    DefaultAction: TRadioGroup;
    ClearMethodNameListByHostChange: TCheckBox;
    FontDialog: TFontDialog;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    FontNameList: TComboBox;
    chkBeep: TCheckBox;
    GroupBox3: TGroupBox;
    RemoveXMLWhiteSpace: TCheckBox;
    UTF8ToWideConversion: TCheckBox;
    FontSize: TComboBox;
    Label5: TLabel;
    OpenListItem: TMenuItem;
    OpenServiceListFile: TAction;
    OpenServiceListDialog: TOpenDialog;
    Service: TComboBox;
    Label6: TLabel;
    host: TEdit;
    RequestInfoLabel: TLabel;
    OpenServiceListFileBtn: TSpeedButton;
    ActionExit: TAction;
    ActionHelp: TAction;
    ActionAbout: TAction;
    ActionYubin: TAction;
    ActionXMLRPCSpec: TAction;
    ActionXMLRPCHowTo: TAction;
    ActionXMLRPCHowToJapan: TAction;
    ActionXMLRPCIntro: TAction;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ExecuteRequestBtnClick(Sender: TObject);
    procedure RequestChange(Sender: TObject);
    procedure listMethodsBtnClick(Sender: TObject);
    procedure methodHelpBtnClick(Sender: TObject);
    procedure BothBtnClick(Sender: TObject);
    procedure MethodNameListDblClick(Sender: TObject);
    procedure methodSignatureBtnClick(Sender: TObject);
    procedure httpStatus(ASender: TObject; const AStatus: TIdStatus;
      const AStatusText: String);
    procedure ClearMetodNamesBtnClick(Sender: TObject);
    procedure OpenRequestFileExecute(Sender: TObject);
    procedure ApplicationEvents1Hint(Sender: TObject);
    procedure FileListBoxDblClick(Sender: TObject);
    procedure DirectoryListBoxChange(Sender: TObject);
    procedure DriveComboBoxChange(Sender: TObject);
    procedure FilterComboBoxChange(Sender: TObject);
    procedure FileListBoxClick(Sender: TObject);
    procedure FontNameListChange(Sender: TObject);
    procedure httpWorkBegin(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCountMax: Integer);
    procedure httpWorkEnd(Sender: TObject; AWorkMode: TWorkMode);
    procedure httpWork(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCount: Integer);
    procedure httpRedirect(Sender: TObject; var dest: String;
      var NumRedirect: Integer; var Handled: Boolean;
      var VMethod: TIdHTTPMethod);
    procedure FontSizeChange(Sender: TObject);
    procedure OpenServiceListFileExecute(Sender: TObject);
    procedure ServiceChange(Sender: TObject);
    procedure ActionExitExecute(Sender: TObject);
    procedure ActionHelpExecute(Sender: TObject);
    procedure ActionAboutExecute(Sender: TObject);

    procedure OpenURL(AURL: string);
    procedure ActionYubinExecute(Sender: TObject);
    procedure ActionXMLRPCHowToJapanExecute(Sender: TObject);
    procedure ActionXMLRPCHowToExecute(Sender: TObject);
    procedure ActionXMLRPCIntroExecute(Sender: TObject);
    procedure ActionXMLRPCSpecExecute(Sender: TObject);
  private
    { Private declarations }
    FIni: TIniFile;
    FLogFile: TextFile;
    FServices: TOpml;
    FLogFileName: string;

    function Execute(ARequestXML: string): TXMLRPCResponse;
    procedure CheckRequest;

    procedure SetResult(AXMLRPCResponse: TXMLRPCResponse); overload;
    procedure SetResult(AXMLRPCResponse: TXMLRPCResponse; ATabSheet: TTabSheet); overload;

    function ExecuteMethodHelp(AMethodName: string): string;
    function ExecuteMethodSignature(AMethodName: string): string;

    procedure LogWrite(AStr: string);
    function GetLogFileName: string;

    procedure LoadServiceFile(AFileName: string);
    procedure SetStatus(AStatusText: string);
  public
    { Public declarations }
    property LogFileName: string read GetLogFileName write FLogFileName;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

{ *** utility *** }

function GetProductVersion(AFileName: string): string;
begin
     with TVersionResource.Create(AFileName) do
     begin
      try
       Result := ProductVersion;
      finally
       Free;
      end;
     end;
end;

function GetProductName(AFileName: string): string;
begin
     with TVersionResource.Create(AFileName) do
     begin
      try
       Result := ProductName;
      finally
       Free;
      end;
     end;
end;

function GetAppTitle: string;
begin
     Result := GetProductName(Application.ExeName)+' ver.'+ GetProductVersion(Application.ExeName);
end;


function AppPath: string;
begin
     Result := ExtractFilePath(Application.ExeName);
end;

function GetTempPath: string;
begin
     Result := AppPath+'temp\';
     ForceDirectories(Result);
end;

function GetTempFile: string;
var
   ATempFile: array[0..255] of char;
begin
     GetTempFileName(PChar(GetTempPath),'_',0,ATempFile);
     Result := ATempFile;
end;

function GetExecutable(AExt: string): string;
var
   ret: integer;
   F: file;
   TempName: string;
   ExeName: array[0..255]of char;
begin
     FillChar(ExeName,SizeOf(ExeName),#0);
     TempName:= ChangeFileExt(GetTempFile,'.'+AExt);
     try
        AssignFile(F, TempName);
        Rewrite(F, 1);
        CloseFile(F);
        ret := FindExecutable(PChar(ExtractFileName(TempName)), PChar(ExtractFilePath(TempName)), ExeName);
        if ret > 32 then
           Result := StrPas(ExeName)
        else
            raise Exception.Create(Format('[%s] not found. errcode:%d',[AExt,ret]));
     finally
        DeleteFile(pChar(TempName));
     end;
end;

function ExecuteFile(const FileName,Params,DefaultDir: string; ShowCmd: Integer): THandle;
begin
  Result := ShellExecute(Application.Handle,nil,
            PChar(FileName), PChar(Params),
            PChar(DefaultDir), ShowCmd);
end;


{ *** main form start *** }
procedure TMainForm.SetStatus(AStatusText: string);
begin
    StatusBar.Panels[1].Text := AStatusText;
    StatusBar.Repaint;
end;

procedure TMainForm.LogWrite(AStr: string);
begin
    AssignFile(FLogFile,LogFileName);
    if FileExists(LogFileName) then Append(FLogFile)
    else Rewrite(FLogFile);
    try
     WriteLn(FLogFile,Format('%s'#9'%s',[FormatDateTime('yyyy-mm-dd hh:nn:ss',Now),AStr]));
    finally
     CloseFile(FLogFile);
    end;
end;

function TMainForm.GetLogFileName: string;
begin
     if FLogFileName='' then
         Result := ChangeFileExt(Application.ExeName,'.log')
     else
         Result := FLogFileName;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
   i: integer;
begin
     Application.Title := GetAppTitle;
     Caption := Application.Title;
     RequestInfoLabel.Caption := '';

     //idHTTP component settings.
     http.Request.Accept := 'text/xml, */*';
     http.Request.UserAgent := Format('Mozilla/3.0 (compatible; %s poweredIndy Library)',[Application.Title]);
     // !! VERY IMPORTANT !!
     http.HTTPOptions := [hoForceEncodeParams];

     Introspects.Enabled := false;

     Request.Lines.Clear;
     ResponseMsg.Lines.Clear;
     Request.Lines.Text := DEFAULT_REQUEST;
     Response.Lines.Clear;
     ExecuteRequestBtn.Enabled := false;

     FIni := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));

     DirectoryListBox.Directory := FIni.ReadString('default','DirectoryListBox',DirectoryListBox.Directory);

     Font.Name := FIni.ReadString('config','FontName',Font.Name);
     //font list
     FontNameList.Items.Assign(Screen.Fonts);
     for i := FontNameList.Items.Count-1 downto 0 do
      if Copy(FontNameList.Items[i],1,1)='@' then
      begin
       FontNameList.Items.Delete(i);
      end;
     for i := FontNameList.Items.Count-1 downto 0 do
      if FontNameList.Items[i] = Font.Name then
      begin
       FontNameList.ItemIndex := i;
       break;
      end;

     Font.Size := FIni.ReadInteger('config','FontSize',Font.Size);
     if Font.Size<9 then Font.Size := 9;
     if Font.Size>12 then Font.Size := 12;
     for i := FontSize.Items.Count-1 downto 0 do
      if FontSize.Items[i] = IntToStr(Font.Size) then
      begin
       FontSize.ItemIndex := i;
       break;
      end;

     chkBeep.Checked := FIni.ReadBool('config','beep',chkBeep.Checked);
     RemoveXMLWhiteSpace.Checked := FIni.ReadBool('config','RemoveXMLWhiteSpace',RemoveXMLWhiteSpace.Checked);
     UTF8ToWideConversion.Checked := FIni.ReadBool('config','UTF8ToWideConversion',UTF8ToWideConversion.Checked);
     ClearMethodNameListByHostChange.Checked := FIni.ReadBool('config','ClearMethodNameListByHostChange',ClearMethodNameListByHostChange.Checked);

     ResponseMsg.Height := FIni.ReadInteger('Position','ResponseMsgHeight',ResponseMsg.Height);
     Top := FIni.ReadInteger('Position','Top',0);
     Left := FIni.ReadInteger('Position','Left',0);

     host.Text := FIni.ReadString('Connection','host','');
     uri.Text := FIni.ReadString('Connection','uri','');
     port.Text := IntToStr(FIni.ReadInteger('Connection','port',80));

     FServices := TOpml.Create;
     if FileExists(AppPath+DEFAULT_SERVICE) then
        LoadServiceFile(AppPath+DEFAULT_SERVICE);

     proxyhost.Text := FIni.ReadString('Proxy','host','');
     proxyport.Text := IntToStr(FIni.ReadInteger('Proxy','port',8080));

     DefaultAction.ItemIndex := FIni.ReadInteger('default','DefaultAction',DefaultAction.ItemIndex);

     PagesRoot.ActivePage := tabXMLRPC;
     Pages.ActivePage := tabSystem;

     //URLs
     ActionHelp.Hint := AppPath+'manual\index.html';
     ActionYubin.Hint := 'http://yubin.senmon.net/service/xmlrpc.html';
     ActionXMLRPCSpec.Hint := 'http://www.xmlrpc.com/spec';
     ActionXMLRPCHowTo.Hint := 'http://www.tldp.org/HOWTO/XML-RPC-HOWTO/';
     ActionXMLRPCHowToJapan.Hint := 'http://www.linux.or.jp/JF/JFdocs/XML-RPC-HOWTO/';
     ActionXMLRPCIntro.Hint := 'http://scripts.incutio.com/xmlrpc/introspection.html';
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
     FServices.Free;

     FIni.WriteString('default','DirectoryListBox',DirectoryListBox.Directory);

     FIni.WriteInteger('config','FontSize',Font.Size);
     FIni.WriteString('config','FontName',Font.Name);
     FIni.WriteInteger('default','DefaultAction',DefaultAction.ItemIndex);

     FIni.WriteBool('config','Beep',chkBeep.Checked);
     FIni.WriteBool('config','RemoveXMLWhiteSpace',RemoveXMLWhiteSpace.Checked);
     FIni.WriteBool('config','UTF8ToWideConversion',UTF8ToWideConversion.Checked);

     FIni.WriteInteger('Position','ResponseMsgHeight',ResponseMsg.Height);
     FIni.WriteInteger('Position','Top',Top);
     FIni.WriteInteger('Position','Left',Left);

     FIni.WriteString('Proxy','host',proxyhost.Text);
     FIni.WriteString('Proxy','port',proxyport.Text);

     FIni.WriteString('Connection','host',host.Text);
     FIni.WriteString('Connection','uri',uri.Text);
     FIni.WriteInteger('Connection','port',StrToIntDef(port.Text,80));

     FIni.Free;
end;

procedure TMainForm.CheckRequest;
begin
    if Trim(host.Text) = '' then raise Exception.Create('Host name is required');
    if (Trim(port.Text) = '') or (StrToIntDef(Trim(port.Text),-1)<0) then raise Exception.Create('Port is required');
    if Trim(uri.Text) = '' then raise Exception.Create('End Point is required');

    http.Host := host.Text;
    http.Port := StrToIntDef(port.Text,80);

    if Trim(ProxyHost.text) <> '' then
    begin
      http.ProxyParams.ProxyServer := Trim(ProxyHost.text);
      http.ProxyParams.ProxyPort := StrToInt(Trim(ProxyPort.text));
    end;
end;

function TMainForm.Execute(ARequestXML: string): TXMLRPCResponse;
var
   AStream: TStringStream;
   AResponse: string;
begin
     CheckRequest;

     Screen.Cursor := crHourGlass;
     AStream := TStringStream.Create(ARequestXML);
     try
      AResponse := http.Post(uri.Text,AStream);
      Result := TXMLRPCResponse.Create(AResponse,UTF8ToWideConversion.Checked,RemoveXMLWhiteSpace.Checked);
     finally
      AStream.Free;
      Screen.Cursor := crDefault;
     end;
end;

procedure TMainForm.RequestChange(Sender: TObject);
begin
     ExecuteRequestBtn.Enabled := Request.Lines.Text<>'';
end;

procedure TMainForm.SetResult(AXMLRPCResponse: TXMLRPCResponse; ATabSheet: TTabSheet);
begin
     with AXMLRPCResponse do
     begin
      if (IsFault) then
      begin
       if chkBeep.Checked then begin Beep;Beep;Beep; end;
       Response.Font.Color := clRed;
       ResponseMsg.Lines.Add(Format('#%d : %s',[faultCode,faultString]));
      end
      else
      begin
       if chkBeep.Checked then begin Beep; end;
       Response.Font.Color := clWindowText;
      end;
      Response.Lines.Add(GetAsXML);
      Pages.ActivePage := ATabSheet;
     end;
end;

procedure TMainForm.SetResult(AXMLRPCResponse: TXMLRPCResponse);
begin
     SetResult(AXMLRPCResponse,tabResponse);
end;

procedure TMainForm.ExecuteRequestBtnClick(Sender: TObject);
var
   AXMLRPCResp: TXMLRPCResponse;
begin
    LogWrite(ConvertWS(Request.Lines.Text,True));
    AXMLRPCResp := Execute(Request.Lines.Text);
    try
     Response.Lines.Clear;
     ResponseMsg.Lines.Clear;
     SetResult(AXMLRPCResp);
     LogWrite(ConvertWS(AXMLRPCResp.GetAsXML,True));
    finally
     AXMLRPCResp.Free;
    end;
end;

//system.listMethods
procedure TMainForm.listMethodsBtnClick(Sender: TObject);
var
   AResponseXml: string;
   AListMethods: TXMLRPCListMethods;
   i: integer;
begin
    Response.Lines.Clear;
    try
     AResponseXml := Execute(SYSTEM_LIST_METHODS).GetAsXML(false);
     AListMethods := TXMLRPCListMethods.Create(AResponseXml,UTF8ToWideConversion.Checked,RemoveXMLWhiteSpace.Checked);
     try
       SetResult(AListMethods,tabSystem);
       MethodNameList.Items.Clear;
       Introspects.Enabled := AListMethods.Values.Count>0;
       for i := 0 to AListMethods.Values.Count-1 do
         MethodNameList.Items.Add(AListMethods.Values[i]);
       if Introspects.Enabled then MethodNameList.ItemIndex := 0;

       SetStatus('');
     finally
      AListMethods.Free;
     end;
    except
     on E: Exception do
     begin
      LogWrite(E.Message);
      raise;
     end;
    end;
end;


function TMainForm.ExecuteMethodHelp(AMethodName: string): string;
var
   AResponseXml,ARequestXml: string;
   AMethodHelp: TXMLRPCMethodHelp;
begin
    try
     ARequestXml := Format(SYSTEM_METHOD_HELP,[AMethodName]);
     Request.Lines.Text := ARequestXml;
     AResponseXml := Execute(ARequestXml).GetAsXML(false);
     AMethodHelp := TXMLRPCMethodHelp.Create(AResponseXml,UTF8ToWideConversion.Checked,RemoveXMLWhiteSpace.Checked);
     try
      SetResult(AMethodHelp);
      Result := AMethodHelp.Help;

      SetStatus('');
     finally
      AMethodHelp.Free;
     end;
    except
     on E: Exception do
     begin
      LogWrite(E.Message);
      raise;
     end;
    end;
end;

//system.methodHelp̌Ăяo
procedure TMainForm.methodHelpBtnClick(Sender: TObject);
begin
     if (MethodNameList.ItemIndex<0) then
     begin
       ShowMessage('Select method name first!');
       exit;
     end;
     Response.Lines.Clear;
     ResponseMsg.Lines.Clear;
     ResponseMsg.Lines.Add(ExecuteMethodHelp(MethodNameList.Items[MethodNameList.ItemIndex]));
end;

function TMainForm.ExecuteMethodSignature(AMethodName: string): string;
var
   AResponseXml,ARequestXml: string;
   AMethodSig: TXMLRPCMethodSignature;
   i: integer;
begin
    try
     ARequestXml := Format(SYSTEM_METHOD_SIG,[AMethodName]);
     Request.Lines.Text := ARequestXml;
     AResponseXml := Execute(ARequestXml).GetAsXML(false);
     AMethodSig := TXMLRPCMethodSignature.Create(AResponseXml,UTF8ToWideConversion.Checked,RemoveXMLWhiteSpace.Checked);
     try
      SetResult(AMethodSig);
      for i := 0 to AMethodSig.Params.Count-1 do
      if (i=0) then
       Result := Result + Format('return %s'#13#10,[AMethodSig.Params[i]])
      else
        Result := Result + Format('param#%d %s'#13#10,[i,AMethodSig.Params[i]]);

      SetStatus('');
     finally
      AMethodSig.Free;
     end;
    except
     on E: Exception do
     begin
      LogWrite(E.Message);
      raise;
     end;
    end;
end;

//system.methodSignaturěĂяo
procedure TMainForm.methodSignatureBtnClick(Sender: TObject);
begin
     if (MethodNameList.ItemIndex<0) then
     begin
       ShowMessage('Select method name first!');
       exit;
     end;
     Response.Lines.Clear;
     ResponseMsg.Lines.Clear;
     ResponseMsg.Lines.Add(ExecuteMethodSignature(MethodNameList.Items[MethodNameList.ItemIndex]));
end;


procedure TMainForm.BothBtnClick(Sender: TObject);
var
   AMethodName: string;
begin
     if (MethodNameList.ItemIndex<0) then
     begin
       ShowMessage('Select method name first!');
       exit;
     end;

     AMethodName := MethodNameList.Items[MethodNameList.ItemIndex];

     ResponseMsg.Lines.Clear;
     Response.Lines.Clear;

     ResponseMsg.Lines.Add('');
     ResponseMsg.Lines.Add(Format(TITLE_HELP,[AMethodName]));
     Response.Lines.Add('');
     Response.Lines.Add(Format(TITLE_HELP,[AMethodName]));

     //Call and get Help
     ResponseMsg.Lines.Add(ExecuteMethodHelp(AMethodName));

     ResponseMsg.Lines.Add('');
     ResponseMsg.Lines.Add(Format(TITLE_SIG,[AMethodName]));
     Response.Lines.Add('');
     Response.Lines.Add(Format(TITLE_SIG,[AMethodName]));

     //Call and get Signature
     ResponseMsg.Lines.Add(ExecuteMethodSignature(AMethodName));
end;

procedure TMainForm.MethodNameListDblClick(Sender: TObject);
begin
    case (DefaultAction.ItemIndex) of
     0: BothBtnClick(Sender);
     1: methodHelpBtnClick(Sender);
     2: methodSignatureBtnClick(Sender);
    end;
end;

procedure TMainForm.httpStatus(ASender: TObject; const AStatus: TIdStatus;
  const AStatusText: String);
var
   AMsg: string;
begin
    case AStatus of
     hsResolving, hsConnecting, hsConnected, hsDisconnecting, hsDisconnected, hsStatusText, ftpTransfer, ftpReady, ftpAborted:
     begin
       AMsg := Format('TCP [%s]',[AStatusText]);
       SetStatus(AMsg);
       LogWrite(AMsg);
     end;
    end;
end;

procedure TMainForm.ClearMetodNamesBtnClick(Sender: TObject);
begin
     MethodNameList.Items.Clear;
end;

procedure TMainForm.LoadServiceFile(AFileName: string);
var
   AItem: TOpmlItem;
   i: integer;
begin
   try
    FServices.LoadFromFile(AFileName);

    Service.Items.Clear;
    for i := 0 to FServices.Items.Count-1 do
    if (FServices.Items[i] is TOpmlItem) then
    begin
     AItem := TOpmlItem(FServices.Items[i]);
     if AItem.OpmlType='xmlrpc' then
        Service.Items.AddObject(Trim(AItem.Text),AItem)
     else Service.Items.Add(Format(DELIM_MARK+' %s '+DELIM_MARK,[Trim(AItem.Text)]));
    end;
    if (Service.Items.Count>0) and (host.Text='') then
    begin
        Service.ItemIndex := 0;
        Service.OnChange(self);
    end;

{$IFDEF DEBUG}
    FServices.SaveToFile('debug.txt');
    FServices.LogStrings.SaveToFile('debug-opml.txt');
{$ENDIF}
   except
    on E: Exception do
    begin
     LogWrite(E.Message);
    end;
   end;
end;

procedure TMainForm.ApplicationEvents1Hint(Sender: TObject);
begin
     StatusBar.Panels[1].Text := Application.Hint;
end;

procedure TMainForm.FileListBoxDblClick(Sender: TObject);
begin
     FileListBoxClick(Sender);
     if (IsValidXMLRPCRequest(Request.Lines)) then ExecuteRequestBtn.Click
end;

procedure TMainForm.DirectoryListBoxChange(Sender: TObject);
begin
     DriveComboBox.Drive := DirectoryListBox.Drive;
     FileListBox.Directory := DirectoryListBox.Directory;
end;

procedure TMainForm.DriveComboBoxChange(Sender: TObject);
begin
     DirectoryListBox.Drive := DriveComboBox.Drive;
end;

procedure TMainForm.FilterComboBoxChange(Sender: TObject);
begin
     FileListBox.Mask := FilterComboBox.Mask;
end;

procedure TMainForm.FileListBoxClick(Sender: TObject);
begin
     Request.Lines.LoadFromFile(FileListBox.FileName);
     with TXMLRPCRequest.Create(Request.Lines.Text,UTF8ToWideConversion.Checked,RemoveXMLWhiteSpace.Checked) do
     begin
      try
       Request.Lines.Text := GetAsXml(UTF8ToWideConversion.Checked);
       RequestInfoLabel.Caption := RequestMethodName;
      finally
       Free;
      end;
     end;
end;

procedure TMainForm.FontNameListChange(Sender: TObject);
begin
    Font.Name := FontNameList.Items[FontNameList.ItemIndex];
end;

procedure TMainForm.FontSizeChange(Sender: TObject);
begin
    Font.Size := StrToIntDef(FontSize.Text,9);
end;


procedure TMainForm.httpWorkBegin(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCountMax: Integer);
var
   AMsg: string;
begin
    if AWorkMode = wmRead then
    begin
       AMsg := Format('TCP Read start. [MAX %d bytes]',[AWorkCountMax]);
       SetStatus(AMsg);
       LogWrite(AMsg);
    end
    else
    begin
       AMsg := Format('TCP Write start. [MAX %d bytes]',[AWorkCountMax]);
       SetStatus(AMsg);
       LogWrite(AMsg);
    end;
end;

procedure TMainForm.httpWorkEnd(Sender: TObject; AWorkMode: TWorkMode);
begin
     if AWorkMode = wmRead then SetStatus('TCP Read end.')
     else SetStatus('TCP Write end.');
end;

procedure TMainForm.httpWork(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCount: Integer);
var
   AMsg: string;
begin
    if AWorkMode = wmRead then
    begin
       AMsg := Format('TCP Reading... %d bytes',[AWorkCount]);
       SetStatus(AMsg);
       LogWrite(AMsg);
    end
    else
    begin
       AMsg := Format('TCP Writing... %d bytes',[AWorkCount]);
       SetStatus(AMsg);
       LogWrite(AMsg);
    end;
end;

procedure TMainForm.httpRedirect(Sender: TObject; var dest: String;
  var NumRedirect: Integer; var Handled: Boolean;
  var VMethod: TIdHTTPMethod);
var
  AMsg: string;
begin
     AMsg := Format('TCP HTTP Redirect to %s. [%d reqs.]',[dest,NumRedirect]);
     SetStatus(AMsg);
     LogWrite(AMsg);
end;

// Common Actions
procedure TMainForm.OpenRequestFileExecute(Sender: TObject);
var
   AFileName: string;
begin
     if (OpenDialog.Execute) then
     begin
      AFileName := OpenDialog.FileName;
      Request.Lines.LoadFromFile(AFileName);
      Pages.ActivePage := tabRequest;
     end;
end;

procedure TMainForm.OpenServiceListFileExecute(Sender: TObject);
var
   AFileName: string;
begin
     if (OpenServiceListDialog.Execute) then
     begin
      AFileName := OpenServiceListDialog.FileName;
      LoadServiceFile(AFileName);
     end;
end;

procedure TMainForm.ServiceChange(Sender: TObject);
var
   idx:integer;
begin
     idx := Service.ItemIndex;
     if (idx>=0) and (Service.Items.Objects[idx] is TOpmlItem) then
     begin
      with TOpmlItem(Service.Items.Objects[idx]) do
      if (GetOpmlAttr('type')='class') then exit
      else
       if (GetOpmlAttr('type')='xmlrpc') then
       begin
         host.Text := GetOpmlAttr('host');
         port.Text := GetOpmlAttr('port');
         uri.Text := GetOpmlAttr('uri');

         if (ClearMethodNameListByHostChange.Checked) then
         begin
          MethodNameList.Items.Clear;
          Introspects.Enabled := false;
         end;
       end;
     end;
end;

procedure TMainForm.ActionExitExecute(Sender: TObject);
begin
     Close;
end;

procedure TMainForm.OpenURL(AURL: string);
begin
     ExecuteFile(AURL,'','',SW_SHOW);
end;

procedure TMainForm.ActionAboutExecute(Sender: TObject);
begin
     ShowMessage(GetAppTitle);
end;

procedure TMainForm.ActionHelpExecute(Sender: TObject);
begin
     OpenURL(ActionHelp.Hint);
end;

procedure TMainForm.ActionYubinExecute(Sender: TObject);
begin
     OpenURL(ActionYubin.Hint);
end;

procedure TMainForm.ActionXMLRPCHowToJapanExecute(Sender: TObject);
begin
     OpenURL(ActionXMLRPCHowToJapan.Hint);
end;

procedure TMainForm.ActionXMLRPCHowToExecute(Sender: TObject);
begin
     OpenURL(ActionXMLRPCHowTo.Hint);
end;

procedure TMainForm.ActionXMLRPCIntroExecute(Sender: TObject);
begin
     OpenURL(ActionXMLRPCIntro.Hint);
end;

procedure TMainForm.ActionXMLRPCSpecExecute(Sender: TObject);
begin
     OpenURL(ActionXMLRPCSpec.Hint);
end;

end.
